"""
1. Select both objects making the one with the hair style the active one then 
   use 'copy active to selected objects' to copy the particle system to the other 
   object.
2. Hit Free Edit on the newly created particle system instance
3. run bpy.ops.particles.new() by clicking the little plus icon to duplicate the 
   current particle settings.

You should now have a unique particle system that has all the same setting as 
the original one except all edits have been lost (don't change it's settings yet).

4. Go into particle edit mode and comb a few hairs it doesn't actually matter what
   you do it just needs to become an edited particle system again.

5. Now go back to object mode, keeping the object selected, select the object with 
   the original hair system i.e the one with the hair style you want to copy so it 
   becomes the active object again.

6. Run this script and execute the operator [space bar]->Copy Hair Edits and that 
   should be it.

I really don't know if this is all needed or not but it's the only solution I can
come up with. A lot of this process can probably be automated but it's 4:30am 
here and I have to get some sleep! So maybe tomorrow (GMT time) I can help you more 
if you are still stuck.

Hope it helps a bit.
"""
import bpy

class OP_CopyHairEdits(bpy.types.Operator):
    bl_idname = "particle.copy_hair_edits"
    bl_label = "Copy Hair Edits"

    def execute(self, context):
      selected = bpy.context.selected_objects 

      active_ob = bpy.context.active_object
      sel_obs = [o for o in selected if o != active_ob]

      for i in range(0, len(active_ob.particle_systems)):

          source_ps = active_ob.particle_systems[i]

          for sel_ob in sel_obs:
              target_ps = sel_ob.particle_systems[i]

              for j in range(0, len(source_ps.particles)):
                  sp = source_ps.particles[j]
                  tp = target_ps.particles[j]

                  for k in range(0, len(sp.hair_keys)):
                      tp.hair_keys[k].co = sp.hair_keys[k].co
              sel_ob.data.update()

      context.scene.update()

      return {'FINISHED'}

def register():
    bpy.utils.register_class(OP_CopyHairEdits)

def unregister():
    bpy.utils.unregister_class(OP_CopyHairEdits)

if __name__ == '__main__':
    register()